
#include <p33EV256GM106.h>

#ifndef CONSTANTS_H
#define CONSTANTS_H

#include <xc.h>

#define  THRESHOLD_VOLTAGE_ONE        615   
#define  THRESHOLD_VOLTAGE_TWO        717  
#define  THRESHOLD_LOWER_VOLTAGE_ONE  490   
#define  THRESHOLD_LOWER_VOLTAGE_TWO  512    
#define  TOTALPWMLEGS 6U
//#define  FCY                 20000000UL
#define  FOSC                40000000UL
#define  CRYSTAL_FCY 		 10000000UL      											
#define  I2C_FSCL			 400000       											
#define  I2C_Baud			 ((CRYSTAL_FCY/I2C_FSCL)-(CRYSTAL_FCY/1111111))-1		
//#define  F_IN1 _RC7 
#define  F_IN2  _RC6  														      
#define  TRUE                     1U												
#define  FALSE                    0U
#define  ON  1
#define  OFF 0
#define  ZERO			          0U													
#define  MAX_TIMER_VAL        65535U  											                                        
#define  PWM_RES_VAL		  0X9B6A												
#define  PTPER_RES_VAL		  0x4e1f	
#define  ONEKILO 1000U
#define  HUNDRED 100U
#define  H1L1      2U
#define  H2L2      4U
#define  H3L3      6U
#define MAX_TIMER_VAL 65535U
#define LOG2          0.30103
//#define BITRATE 500000U  
//#define NTQ 	10U		
#define BRP_VAL		((FCY/(2*NTQ*BITRATE))-1)
#define CAN_FRAME_STD 0x04
#define CAN_BUF_FULL 0x05
#define CAN_BUF_EMPTY 0x06
#define CAN_MSG_DATA 0x01
#define CAN_MSG_RTR 0x02
#define ARYSIZTWO   2
#define TWELEVE    12
#define SIX        6
#define POW2       2
#define TWO        2U
#define FOUR       4U
#define ONE        1U

#define  ECAN1_MSG_BUF_LENGTH 	4U

#define ENABLEBIT  0x8000

#define ANALOG_CHANNELS 9

#define AUTOCONVERSION 7
#define AUTOSAMPTIME 31



#define PDC_PRESCALAR 1U
#define LOG2 0.30103
#define PWMMODE 0x0700

/* port declaration*/
#define FIVE_VOLT_CTRL_TRIS _TRISD6
#define FIVE_VOLT_CTRL_PORT PORTDbits.RD6 
#define ENABLE_VOLT_48_CTRL_TRIS _TRISD8
#define ENABLE_VOLT_48_CTRL_PORT _RD8
#define POWER_GOOD_SIGNAL_TRIS  _TRISG8
#define POWER_GOOD_SIGNAL_PORT PORTGbits.RG8
#define MICROCON_ENABLE_SIG_IN_TRIS _TRISB7
#define MICROCON_ENABLE_SIG_IN_PORT PORTBbits.RB7
#define MICROCON_ENABLE_SIG_OUT_TRIS _TRISG9
#define MICROCON_ENABLE_SIG_OUT_PORT _RG9

#define ENABLE_48V_SW_OUT_TRIS _TRISD8
#define ENABLE_48V_SW_OUT_PORT _RD8

#define WD_EN_IN_TRIS  _TRISD5
#define WD_EN_IN_PORT  _RD5

#define COMP_OUT_TRIS _TRISC8
#define COMP_OUT_PORT _RC8

#define WD_SERVICE_SIG_TRIS _TRISC7
#define WD_SERVICE_SIG_PORT _RC7


#define EEPROM_WP_SIG_PORT _RC13

#define HBRIDGE_CONTROL_PORT _RA8
#define HBL2_ENABLE_PORT _RC3
#define HBH2_ENABLE_PORT _RA9
#define STATOR_DRIVE_PORT _RA10



#endif
