/*
 * File:   comparator.c
 * Author: mshailen
 *
 * Created on July 20, 2017, 2:08 PM
 */

/******************************************************************************
 *****************************************************************************
 Section: Included Files
 *****************************************************************************
 *****************************************************************************/
#include<xc.h>
#include "types.h"

/******************************************************************************
 *****************************************************************************
 Section: Macro definition
 *****************************************************************************
 *****************************************************************************/
 



/******************************************************************************
 *****************************************************************************
 Section: function prototype
 *****************************************************************************
 *****************************************************************************/


uchar8_t g_Comp_One_Status_u8=0u;

 uchar8_t g_enable_switchingtable_u8;
 uchar8_t g_hall_a_greterthan_hall_b_u8;
 uchar8_t g_hall_b_greterthan_hall_c_u8;
 uchar8_t g_hall_c_greterthan_hall_a_u8;
 uchar8_t g_enable_alt_switchingtable_u8;
 uchar8_t g_alternator_cntrl_flag_u8;
 uchar8_t g_speedlessthanSet_u8;

 uchar8_t g_switching_flag_u8;
void ComparatorInit(void);
void ComparatorOut(void);
void Swithcing_180(void);
void SwitchingTable_120_Alternatormode(void);
void SwitchingTable_120_motormode(void);


void ComparatorInit(void)
{
    RPOR7 = 0x18;
    ANSELAbits.ANSA0 = 1 ; /* PIN No 13 HALL A :RA0 :Ensure configure as analog */ 
    _TRISA0 = 1;  // C2IN4+ INPUT Reference to HALLB.

    ANSELAbits.ANSA1 = 1; /* PIN No 14 HALL B :RA1 :Ensure configure as analog */
    _TRISA1 = 1;  // C2IN1+ INPUT .
    
    
    ANSELBbits.ANSB2 = 1; /* PIN No 15 HALL C : RB0 :Ensure configure as analog */
    _TRISB2 = 1; // C2IN1+ INPUT Reference to HALL B
    
    ANSELBbits.ANSB3 = 1; /* PIN No 15 HALL C : RB0 :Ensure configure as analog */
    _TRISB3 = 1; // C2IN1+ INPUT Reference to HALL B
    
    ANSELCbits.ANSC1 = 1; /* PIN No 15 HALL C : RB0 :Ensure configure as analog */
    _TRISC1 = 1; // C2IN1+ INPUT Reference to HALL B
    
    ANSELCbits.ANSC2 = 1; /* PIN No 15 HALL C : RB0 :Ensure configure as analog */
    _TRISC2 = 1; // C2IN1+ INPUT Reference to HALL B
    
    
    IPC4bits.CMIP = 7; // set interrupt priority to 7
    IFS1bits.CMIF = 0; // clear the interrupt flag
    CMSTATbits.PSIDL = 0; // continues operation of all comparators in idle mode
    
    CM1FLTRbits.CFLTREN = 1;
    CM2FLTRbits.CFLTREN = 1;
    CM3FLTRbits.CFLTREN = 1;
    
    CM1FLTRbits.CFSEL = 1;				// Choose CPU instruction clock (TCY) 
    CM2FLTRbits.CFSEL = 1;				// Choose CPU instruction clock (TCY) 
    CM3FLTRbits.CFSEL = 1;				// Choose CPU instruction clock (TCY) 
    
    CM1CON =0x00C0;
    CM1CONbits.COE = 1;
    CM1CONbits.CON = 1;  // enable comparator 1
    CM2CON =0x00C3;
    CM2CONbits.CON = 1;  // enable comparator 2
    CM3CON =0x00C0;
    CM3CONbits.CON = 1;  // enable comparator 3
    IEC1bits.CMIE = 1; // Enable the interrupt
}
extern uchar8_t g_sector;
extern uint16_t Phase;
extern uchar8_t g_sector_array[8];
extern const int PhaseValues[6];
unsigned int LastSector; // This variable holds the last sector value. This 
                         // is critical to filter slow slew rate on the Hall
                         // effect sensors hardware
unsigned int MotorStalledCounter = 0; // This variable gets incremented each 
                                      // 1 ms, and is cleared everytime a new
                                      // sector is detected. Used for 
                                      // ForceCommutation and MotorStalled 
                                      // protection functions
unsigned char Current_Direction;	// Current mechanical motor direction of 
                                    // rotation Calculated in halls interrupts
unsigned char Required_Direction;	// Required mechanical motor direction of 
                                    // rotation, will have the same sign as the
									// ControlOutput variable from the Speed 
                                    // Controller
#define PHASE_OFFSET_CW 10000
//#define PHASE_OFFSET_CW 4100
//#define PHASE_OFFSET_CW 0
#define PHASE_OFFSET_CCW 0

int PhaseOffsetCW = PHASE_OFFSET_CW;
int PhaseOffsetCCW = PHASE_OFFSET_CCW;
#define CW	0		// Counter Clock Wise direction
#define CCW	1		// Clock Wise direction

uchar8_t g_previous_halla_u8=0;
uchar8_t g_present_halla_u8=0;
uchar8_t g_previous_hallb_u8=0;
uchar8_t g_present_hallb_u8=0;
uchar8_t g_previous_hallc_u8=0;
uchar8_t g_present_hallc_u8=0;

void __attribute__((__interrupt__,__no_auto_psv__)) _CMP1Interrupt(void)
{
     uchar8_t l_hallA = 0;
     uchar8_t l_hallB = 0;
     uchar8_t l_hallC = 0;
     uchar8_t l_result =0;
    if(1 == CM2CONbits.CEVT )
    {
        CM2CONbits.CEVT = 0;
        _RB0 = CM2CONbits.COUT;
        g_hall_a_greterthan_hall_b_u8 = CMSTATbits.C2OUT;
        g_previous_halla_u8 = g_present_halla_u8;
        g_present_halla_u8 = g_hall_a_greterthan_hall_b_u8;
    }
    if( 1 == CM3CONbits.CEVT) // Clear comparator 3 event bit)
    {
         CM3CONbits.CEVT = 0; // Clear comparator 3 event bit
         _RB1 = CM3CONbits.COUT;
         g_hall_c_greterthan_hall_a_u8 = CMSTATbits.C3OUT;
         
        g_previous_hallc_u8 = g_present_hallc_u8;
        g_present_hallc_u8 = g_hall_c_greterthan_hall_a_u8;
         
    }
    if(1 == CM1CONbits.CEVT ) // Clear comparator 3 event bit)
    {
        CM1CONbits.CEVT = 0; // Clear comparator 3 event bit
        _RC13 = CM1CONbits.COUT;
        g_hall_b_greterthan_hall_c_u8 = CMSTATbits.C1OUT;
        
        g_previous_hallb_u8 = g_present_hallb_u8;
        g_present_hallb_u8 = g_hall_b_greterthan_hall_c_u8;
    }
    
     l_hallA = g_hall_a_greterthan_hall_b_u8;
     l_hallB = g_hall_b_greterthan_hall_c_u8 << 1;
     l_hallC = g_hall_c_greterthan_hall_a_u8<< 2;
     l_result = l_hallC | l_hallB | l_hallA;
     g_sector = g_sector_array[l_result]; 
     Phase = PhaseValues[g_sector];
     
     // This MUST be done for getting around the HW slow rate
	if (g_sector != LastSector)	
	{
        //port_toggle();
        if(g_previous_halla_u8 != g_present_halla_u8)
        {
           if ((g_sector == 5) || (g_sector == 2))	
           {
			Current_Direction = CW;
           }
		   else
           {
			Current_Direction = CCW; 
           }
        }
        
        if(g_previous_hallb_u8 != g_present_hallb_u8)
        {
           if ((g_sector == 3) || (g_sector == 0))	
           {
			Current_Direction = CW;
           }
		   else
           {
			Current_Direction = CCW; 
           }
        }
        
        if(g_previous_hallc_u8 != g_present_hallc_u8)
        {
           if ((g_sector == 1) || (g_sector == 4))	
           {
			Current_Direction = CW;
           }
		   else
           {
			Current_Direction = CCW; 
            
           }
        }
		// Since a new sector is detected, clear variable that would stop 
        // the motor if stalled.
		MotorStalledCounter = 0;
       
		
        // Motor commutation is actually based on the required direction, not
        // the current dir. This allows driving the motor in four quadrants
	if (Required_Direction == CW)	
		{
            Phase = PhaseValues[(g_sector) % 6] + PhaseOffsetCW;
            
		}
		else
		{
			// For CCW an offset must be added to compensate difference in 
            // symmetry of the sine table used for CW and CCW
			Phase = PhaseValues[(g_sector + 3) % 6]+ PhaseOffsetCCW;
		}
		LastSector = g_sector; // Update last sector
	}

     
    IFS1bits.CMIF = 0; // clear the interrupt flag
}

void ForceCommutation(void)
{
    uchar8_t  HallValue=0;
	
    g_hall_a_greterthan_hall_b_u8 = CMSTATbits.C2OUT;
    g_hall_c_greterthan_hall_a_u8 = CMSTATbits.C3OUT;
    g_hall_b_greterthan_hall_c_u8 = CMSTATbits.C1OUT;
    
    HallValue = g_hall_a_greterthan_hall_b_u8+2*g_hall_b_greterthan_hall_c_u8+4*g_hall_c_greterthan_hall_a_u8;// Read halls		
	g_sector = g_sector_array[HallValue];	// Read sector based on halls
	if (g_sector != -1)	// If the sector is invalid don't do anything
	{
		// Depending on the required direction, a new phase is fetched
		if (Required_Direction == CW)
		{
			// Motor is required to run forward, so read directly the table
			Phase = PhaseValues[(g_sector) % 6] + PhaseOffsetCW;
		}
		else
		{
			// Motor is required to run reverse, so calculate new phase and 
            // add offset to compensate asymmetries
			Phase = PhaseValues[(g_sector + 3) % 6]+ PhaseOffsetCCW;
		}
	}
	return;
}