
/****************************************************************************** 
 Section: Included Files
 *****************************************************************************/
#include <p33EV256GM106.h>
#include "types.h"
#include "motorvariables.h"

/*****************************************************************************
 * Section: MACRO DEFINITION'S
 *****************************************************************************/
//#define PHASE_ZERO 	49152
//#define PHASE_ZERO 	45511 draws 8.0 amps
//#define PHASE_ZERO 	45000 // draws 7.6 amps
#define PHASE_ZERO 	45000 // draws 7.6 amps
#define PHASE_ONE	((PHASE_ZERO + 65536/6) % 65536)
#define PHASE_TWO	((PHASE_ONE + 65536/6) % 65536)
#define PHASE_THREE	((PHASE_TWO + 65536/6) % 65536)
#define PHASE_FOUR	((PHASE_THREE + 65536/6) % 65536)
#define PHASE_FIVE	((PHASE_FOUR + 65536/6) % 65536)
const int PhaseValues[6] =
{PHASE_ZERO, PHASE_ONE, PHASE_TWO, PHASE_THREE, PHASE_FOUR, PHASE_FIVE}; 

uint16_t g_markpulse_a_u16 = 0;
uint16_t g_markpulse_b_u16 = 0;
uchar8_t g_markpulse_a_flag_u8=FALSE;
uchar8_t g_markpulse_b_flag_u8=FALSE;
uchar8_t g_markflag_u8=FALSE;
uint16_t g_encoderpulses_u16=0;
uint16_t g_markflagcounter_u16=0;
uchar8_t g_clockwisedirection_u8=FALSE;
uchar8_t g_anticlockwise_direction_u8 = FALSE;
uchar8_t  g_hallAstatus = 0;
uchar8_t  g_hallBstatus = 0;
uchar8_t  g_hallCstatus = 0;
uint16_t g_previous_ic1capturedate_u16 = 0;
uint16_t g_present_ic1capturedate_u16 = 0;
uint16_t g_ic1_buffervalue_u16  =0;
extern uchar8_t g_sector;
extern uint16_t Phase;

extern uint16_t g_period_u16;
void CalculatePosition(void);
void InputCaptureInitialization(void);
 extern void Sector(void);
 
/*****************************************************************************/
#define EVERYRISINGEDGE_IC1         (0x03U) //3 value
#define EVERY_RISING_FALLING_IC     (0x01U)
#define EVERYCAPTUREEVENT_IC1       (0x00U)
#define TIMER3_IC1                  (0x00U) //0 value 
#define RESET_IC1_STATUS_FLAG       (0x00U)
#define ENABLE_IC1_INTERRUPT        (0x01U)
#define MAP_TO_RP48                 (0x0030u)   /*Configuring to pin no 21 */
#define MAP_TO_RP54                 (0x3600)  /*Configuring to pin no 50*/
#define MAP_TO_RP55                 (0x37u)   /*Configuring to pin no 51 */
#define MAP_TO_RP69                 (0x4500u) /*Configuring to pin no 53 */

/*****************************************************************************
  Section: File Scope Variables, Functions, Initializations
 *****************************************************************************/
 
 
void inputcapture1_init(void)
{ 
 ANSELCbits.ANSC0=0;
 _TRISC0=1;
 RPINR7 |= MAP_TO_RP48; 
 IC1CON1bits.ICM = EVERYRISINGEDGE_IC1;
 IC1CON1bits.ICI = EVERYCAPTUREEVENT_IC1;
 IC1CON1bits.ICTSEL = TIMER3_IC1;
 IFS0bits.IC1IF = RESET_IC1_STATUS_FLAG;	 		// Clear Input Capture1 Flag request
 IEC0bits.IC1IE = ENABLE_IC1_INTERRUPT;		// Enable Input Capture1 Interrupt request
}
uchar8_t g_interrupt_Count = 0u;
uint16_t g_timer_first_edge_u16=0u;
uint16_t g_timer_second_edge_u16=0u;
uint16_t g_period_u16=0u;
uchar8_t g_flag_u8=0;
uint16_t g_pastcapture_u16=0;
uint16_t g_actualcapture_u16=0;
extern unsigned int LastSector; 

/* Implement Input Capture Interrupts if required */
void __attribute__((__interrupt__,__no_auto_psv__)) _IC1Interrupt(void)
{

    if(g_sector != LastSector)
	{
     g_pastcapture_u16 = g_actualcapture_u16;
     g_actualcapture_u16 = IC2BUF;
    }

  IFS0bits.IC1IF=RESET_IC1_STATUS_FLAG;  
  
}






